/* Starsiege Quickchat Generator v2.0 (SQCGen)
 * See sqcgen.html for details.
 * Created by Pincushion - v1.0 March 31, 1999; v2.0 April 14, 1999.
 */
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <windows.h>

static char appname[] = "SQCGen v2.0";
static char csfn[] = "SQCGen.cs";
static char outfn[] = "scripts\\quickchat.cs";
static char buf[1024];
static char sqcgendir[1024];
static char ssdir[1024];
static int verbose = 0;

#define MSGPERSET 9
#define MAXMSG 5000
#if 0
static char *msg[MAXMSG] = {
"Say(\"TargetTeam\",1,\"Excellent.\",\"M1_DM_excellent.WAV\");",
"Say(\"Target\",1,\"Honorless dog!\",\"M1_DM_honorlessdog.WAV\");",
"Say(\"TargetTeam\",1,\"I'm going to burn you!\",\"M1_DM_imgoingto.WAV\");",
"Say(\"TargetTeam\",1,\"See how you like this.\",\"M1_DM_seehowy.WAV\");",
"Say(\"TargetTeam\",1,\"You panic easily.\",\"M1_DM_youpanic.WAV\");",
"Say(\"TargetTeam\",1,\"You're going down!\",\"M1_DM_yourgoing.WAV\");",
"Say(\"Target\",1,\"You're insane--and dead!\",\"M1_DM_yourinsane.WAV\");",
"Say(\"Team\",1,\"Vape 'em!\",\"M1_TDM_vapem.WAV\");",
"Say(\"TargetTeam\",1,\"That shows very poor discipline.\",\"M1_DM_thatshows.WAV\");",
};
#else
static char *msg[MAXMSG];
#endif

static void usage( char *pgm )
{
	fprintf( stderr,
"Usage: %s <sqcfile>\n", pgm );
	fprintf( stderr,
"Where <sqcfile> is a text file containing one Say statement per line which\n");
	fprintf( stderr,
"will be embedded in the proper formatting and written to %s.\n", outfn );
}

int main( int argc, char **argv )
{
	FILE *fp;
	char *fn, *p, *csbuf;
	int i, j, k, csbufsz, ret, nmsg;

	ret = -1;
	if ( (argc < 2) || (argv[1][1]=='?') ) {
		usage( argv[0] );
		goto done;
	}

	/* Infer the Starsiege folder based on where SQCGen.exe lives */
	strcpy( sqcgendir, argv[0] );
	p = strrchr( sqcgendir, '\\' );
	if ( p == 0 ) {
where:
		fprintf( stderr, "%s: Where am I?\n", argv[0] );
		/* guess */
		strcpy( sqcgendir, "." );
		strcpy( ssdir, ".." );
	} else {
		*p = '\0';
		strcpy( ssdir, sqcgendir );
		p = strrchr( ssdir, '\\' );
		if ( p == 0 )
			goto where;
		*p = '\0';
	}

	/* Load .cs file */
	sprintf( buf, "%s\\%s", sqcgendir, csfn );
	fn = buf;
	fp = fopen( fn, "r" );
	if ( fp != 0 ) {
		fseek( fp, 0, SEEK_END );
		csbufsz = ftell( fp );
		csbuf = calloc( csbufsz, 1 );
		fseek( fp, 0, SEEK_SET );
		fread( csbuf, csbufsz, 1, fp );
		fclose( fp );
		csbufsz = strlen( csbuf );
		if ( verbose ) {
			fprintf( stdout, "Header Config:\n" );
			fwrite( csbuf, csbufsz, 1, stdout );
		}
	}

	/* Load message file */
	fn = argv[1];
	fp = fopen( fn, "r" );
	if ( fp == 0 ) {
openerr:
		fprintf( stderr, "%s: Can't open %s.\n", argv[0], fn );
		goto done;
	}
	if ( verbose )
		fprintf( stdout, "Quickchats:\n" );
	for ( i=0 ; i<MAXMSG ; ) {
		fgets( buf, sizeof(buf)-1, fp );
		if ( feof( fp ) )
			break;
		for ( p=buf+strlen(buf)-1 ; (p>=buf) && isspace(*p) ; p-- )
			;
		*++p = '\0';
		if ( (buf[0] == '\0') || (buf[0] == '/') || isspace(buf[0]) )
			continue;
		msg[i] = malloc( strlen(buf)+1 );
		strcpy( msg[i], buf );
		if ( verbose )
			fprintf( stdout, "%s\n", msg[i] );
		++i;
	}
	nmsg = i;
	fclose( fp );

	/* Create output file */
	sprintf( buf, "%s\\%s", ssdir, outfn );
	fn = buf;
	fp = fopen( fn, "w" );
	if ( fp == 0 )
		goto openerr;
	fprintf( fp, "// Generated from %s by %s\n", argv[1], appname );
	if ( csbuf )
		fwrite( csbuf, csbufsz, 1, fp ); 
	fprintf( fp, "function InitQuickChat() { newObject( TauntsVol, SimVolume, \"Taunts.vol\" ); }\n" );
	for ( i=0 ; i<MSGPERSET ; i++ ) {
		fprintf( fp, "function QuickChat%d()\n", i+1 );
		fprintf( fp, "{\n" );
		for ( j=0, k=i ; k<nmsg ; j++, k+=MSGPERSET )
			fprintf( fp, "if ($qcSet == %d) { %s }\n", j+1, msg[k] );
		fprintf( fp, "}\n" );
	}
	fclose( fp );
	printf( "Created %s.\n", outfn );

	ret = 0;
done:
	if ( ret < 0 ) {
		fflush( stderr );
		Sleep( 5000 );
	}
	return( ret );
}
